from Products.ZPatterns.DataSkins import DataSkin
from OFS.PropertyManager import PropertyManager
from Globals import HTMLFile

class EntryDataSkin(DataSkin):
    """ 
    Flat Database entry.
    """
    
    meta_type = "Entry DataSkin"
    
    __ac_permissions__=(
        ('Manage properties', ('manage',
                               'manage_main',
                               'manage_change',
                               'manage_propertiesForm',
                               )),
        ('View', ('index_html',
                  'getProperty',           
                  )),
       )
       
    manage_propertiesForm = HTMLFile("www/entry_propertiesForm", globals())    
    manage = manage_main = manage_propertiesForm
    
    index_html = HTMLFile("www/entry_index_html", globals())
    
    manage_options = (
        {'label':'Properties','action':'manage_propertiesForm'},        
    )
        
    def getProperty(self, id):
        if id in self.database_properties.propertyIds():
            return getattr(self, id, '')
            
    def manage_change(self, REQUEST, RESPONSE):
        """ Change properties """
        for prop in self.database_properties.propertyMap():
            name=prop['id']
            if REQUEST.has_key(name):
                if 'w' in prop.get('mode', 'wd'):
                    value=REQUEST.get(name)
                    setattr(self, name, value)
        RESPONSE.redirect(REQUEST.URL1)

        
def initialize(context):
    context.registerBaseClass(EntryDataSkin)
